Subject: Re: [bug#27637] [PATCH 5/5] gnu: Add conda
From: Ricardo Wurmus <[email-masked]>
To: Pjotr Prins <[email-masked]>
Cc: Muriithi Frederick Muriuki <[email-masked]>, [email-masked]
Date: Sat, 22 Jul 2017 11:49:20 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Ricardo Wurmus <[email-masked]> writes:

> Pjotr Prins <[email-masked]> writes:
>
>> Thanks Fred.
>>
>> Can someone take a look at the tar issue?
>
> The tar thing really looks odd.  I’m ready to push the patches leading
> up to this one.  I still need to experiment a bit to avoid this
> complicated install phase.

I fixed this, but conda still has errors; it tries to write to the
store:

--8<---------------cut here---------------start------------->8---
/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/bin/conda install samtools
Fetching package metadata ...An unexpected error has occurred.
Please consider posting the following information to the
conda GitHub issue tracker at:

    https://github.com/conda/conda/issues

Current conda install:

               platform : linux-64
          conda version : 4.3.16
       conda is private : False
      conda-env version : 4.3.16
    conda-build version : not installed
         python version : 3.5.3.final.0
       requests version : 2.13.0
       root environment : /gnu/store/yd655bpcqrzch4ai1dhs7v39yhm70mdi-python-3.5.3  (read only)
    default environment : /gnu/store/yd655bpcqrzch4ai1dhs7v39yhm70mdi-python-3.5.3
       envs directories : /home/rekado/.conda/envs
                          /gnu/store/yd655bpcqrzch4ai1dhs7v39yhm70mdi-python-3.5.3/envs
          package cache : /gnu/store/yd655bpcqrzch4ai1dhs7v39yhm70mdi-python-3.5.3/pkgs
                          /home/rekado/.conda/pkgs
           channel URLs : https://repo.continuum.io/pkgs/free/linux-64
                          https://repo.continuum.io/pkgs/free/noarch
                          https://repo.continuum.io/pkgs/r/linux-64
                          https://repo.continuum.io/pkgs/r/noarch
                          https://repo.continuum.io/pkgs/pro/linux-64
                          https://repo.continuum.io/pkgs/pro/noarch
            config file : None
           offline mode : False
             user-agent : conda/4.3.16 requests/2.13.0 CPython/3.5.3 Linux/4.1.42-gnu / glibc/2.25
                UID:GID : 1000:1000

`$ /gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/bin/.conda-real install samtools`

    Traceback (most recent call last):
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/exceptions.py", line 626, in conda_exception_handler
        return_value = func(*args, **kwargs)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/cli/main.py", line 134, in _main
        exit_code = args.func(args, p)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/cli/main_install.py", line 80, in execute
        install(args, parser, 'install')
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/cli/install.py", line 221, in install
        unknown=index_args['unknown'], prefix=prefix)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/index.py", line 92, in get_index
        index = fetch_index(channel_priority_map, use_cache=use_cache)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/index.py", line 111, in fetch_index
        repodatas = collect_all_repodata(use_cache, tasks)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/repodata.py", line 74, in collect_all_repodata
        repodatas = _collect_repodatas_serial(use_cache, tasks)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/repodata.py", line 463, in _collect_repodatas_serial
        for url, schan, pri in tasks]
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/repodata.py", line 463, in <listcomp>
        for url, schan, pri in tasks]
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/repodata.py", line 109, in func
        res = f(*args, **kwargs)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/repodata.py", line 409, in fetch_repodata
        cache_path = join(cache_dir or create_cache_dir(), cache_fn_url(url))
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/repodata.py", line 497, in create_cache_dir
        cache_dir = join(PackageCache.first_writable(context.pkgs_dirs).pkgs_dir, 'cache')
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/package_cache.py", line 169, in first_writable
        return cls.all_writable(pkgs_dirs)[0]
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/package_cache.py", line 176, in all_writable
        (PackageCache(pd) for pd in pkgs_dirs)))
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/package_cache.py", line 175, in <lambda>
        writable_caches = tuple(filter(lambda c: c.is_writable,
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/core/package_cache.py", line 316, in is_writable
        self._is_writable = create_package_cache_directory(self.pkgs_dir)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/gateways/disk/create.py", line 302, in create_package_cache_directory
        mkdir_p(pkgs_dir)
      File "/gnu/store/pwl68nzl6s3papdx98hx997iij10r3sn-conda-4.3.16/lib/python3.5/site-packages/conda-4.3.16-py3.5.egg/conda/gateways/disk/create.py", line 160, in mkdir_p
        makedirs(path)
      File "/gnu/store/yd655bpcqrzch4ai1dhs7v39yhm70mdi-python-3.5.3/lib/python3.5/os.py", line 241, in makedirs
        mkdir(name, mode)
    OSError: [Errno 30] Read-only file system: '/gnu/store/yd655bpcqrzch4ai1dhs7v39yhm70mdi-python-3.5.3/pkgs'
--8<---------------cut here---------------end--------------->8---

Wherever it says “/gnu/store/yd655bpcqrzch4ai1dhs7v39yhm70mdi-python-3.5.3/” we should provide sane
defaults.

@Fred: could you please look into this?  This may require patching the
conda sources.

I’m marking this bug done now, because Conda is now in the repository.

-- 
Ricardo

GPG: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
https://elephly.net